/***************************************************************************
***
***    Copyright (c) 1995-1997 by ABKGroup, UCLA VLSI CAD Laboratory,
***    UCLA Computer Science Department, Los Angeles, CA 90095-1596 USA,
***    and by the Regents of the University of California.
***    All rights reserved.
***
***    No portion of this file may be used, copied, or transmitted for
***    any purpose, including any research or commercial purpose,
***    without the express written consent of Professor Andrew B. Kahng,
***    UCLA Computer Science Department, 3713 Boelter Hall, Los Angeles,
***    CA 90095-1596 USA.   Any copy made of this file must include this
***    notice.    ABKGroup and the Regents of the University of California
***    retain title to all copies of this file and/or its compiled
***    derivatives.
***
***************************************************************************/

#include <iostream.h>
#include "ABKCommon/abkcommon.h"
// #include "constraints.h"
// #include "placement.h"
// #include "transf.h"
#include "DB/DB.h"
#include "RBPlace/violations.h"
#include "RBPlaceFromDB.h"
#include "violationReport.h"

int main(int argc, const char *argv[])
{
    StringParam auxFileName    ("f",argc,argv);

    abkfatal(auxFileName.found(),
              " AUX file name missing, See -h for more info\n");

    BoolParam check("checkDB",argc,argv);
    DB::Parameters dbParams;
    dbParams.alwaysCheckConsistency = check;

    DB db(auxFileName,dbParams);


    cout<<"Num Cells in DB "<<db.getNetlist().getNumCells()<<endl;
    cout<<"Num Cores in DB "<<db.getNetlist().getNumCoreCells()<<endl;

    RBPlaceParams rbParams(argc, argv);
    RBPlaceFromDB opl(db, rbParams);

    cout << "=========================================" << endl;
    cout << "Checking legality of Placement" << endl;
    ViolationReport initialVls(db, opl, Verbosity("1_1_2"));
    unsigned initialViols = initialVls.getNumViols();
    cout << "=========================================" << endl;

    cout << "Placement had " << initialViols << " violations." << endl;

    return 0;
}


